
/* Chrysalide - Outil d'analyse de fichiers binaires
 * simd.h - prototypes pour le désassemblage des instructions ARMv7 SIMD
 *
 * Copyright (C) 2016 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_ARM_V7_SIMD_H
#define _ARCH_ARM_V7_SIMD_H


#include <stdbool.h>


#include "../../instruction.h"



/* Désassemble une instruction ARMv7 liées au chapitre A7.4. */
GArchInstruction *process_armv7_simd_advanced_simd_data_processing_instructions(uint32_t, bool);

/* Désassemble une instruction ARMv7 liées au chapitre A7.5. */
GArchInstruction *process_armv7_simd_floating_point_data_processing_instructions(uint32_t, bool);

/* Désassemble une instruction ARMv7 liées au chapitre A7.6. */
GArchInstruction *process_armv7_simd_extension_register_load_store_instructions(uint32_t, bool);

/* Désassemble une instruction ARMv7 liées au chapitre A7.7. */
GArchInstruction *process_armv7_simd_advanced_simd_element_or_structure_load_store_instructions(uint32_t, bool);

/* Désassemble une instruction ARMv7 liées au chapitre A7.8. */
GArchInstruction *process_armv7_simd_8_16_and_32_bit_transfer_between_arm_core_and_extension_registers(uint32_t, bool);

/* Désassemble une instruction ARMv7 liées au chapitre A7.9. */
GArchInstruction *process_armv7_simd_64_bit_transfers_between_arm_core_and_extension_registers(uint32_t, bool);



#endif  /* _ARCH_ARM_V7_SIMD_H */
